﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Security;
using System.Reflection;


public partial class Default2 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		if( this.IsPostBack == false )
			return;

		string action = Request.Form["submit"];
		if( string.IsNullOrEmpty(action) )
			return;

		typeof(Default2).InvokeMember(action, 
					BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.NonPublic,
					null, this, new object[] {});		
    }

	
	
	private void SetSession()
	{
		Session["Key1"] = DateTime.Now;
	}

	
	private void WriteCookie()
	{
		//HttpCookie cookie = new HttpCookie("MyCookieName", "string value");
		//Response.Cookies.Add(cookie);

		string name = Request.Form["name"];
		string value = Request.Form["value"];

		if( string.IsNullOrEmpty(name) == false ) {
			HttpCookie cookie2 = new HttpCookie(name, value);
			Response.Cookies.Add(cookie2);			
		}
	}


	private void WriteCookie_2a()
	{
		DisplaySettings setting = new DisplaySettings { Style = 1, Size = 24 };

		HttpCookie cookie = new HttpCookie("DisplaySettings1");
		cookie["Style"] = setting.Style.ToString();
		cookie["Size"] = setting.Size.ToString();

		Response.Cookies.Add(cookie);
	}


	private void WriteCookie_2b()
	{
		DisplaySettings setting = new DisplaySettings { Style = 2, Size = 48 };

		HttpCookie cookie = new HttpCookie("DisplaySettings2", setting.ToJson());
		Response.Cookies.Add(cookie);
	}
	

	private void DeleteCookie()
	{
		string name = Request.Form["name"];

		if( string.IsNullOrEmpty(name) == false ) {
			HttpCookie cookie = new HttpCookie(name, null);
			cookie.Expires = new DateTime(1900, 1, 1);
			Response.Cookies.Add(cookie);
		}
	}


	private void SetLogin()
	{
		//System.Web.Security.FormsAuthentication.SetAuthCookie("fish", false);

		// 下面的代码和上面的代码在作用上是等效的。
		FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(
			2, "fish", DateTime.Now, DateTime.Now.AddDays(30d), false, string.Empty);
		string str = FormsAuthentication.Encrypt(ticket);

		HttpCookie cookie = new HttpCookie(FormsAuthentication.FormsCookieName, str);
		Response.Cookies.Add(cookie);
	}

	private void SetLogout()
	{
		System.Web.Security.FormsAuthentication.SignOut();
	}


	private void WriteEncryptCookie()
	{
		FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(
			2, string.Empty, DateTime.Now, DateTime.Now.AddDays(1d), false, "一个重要的字符串");
		string encString = FormsAuthentication.Encrypt(ticket);

		HttpCookie cookie = new HttpCookie("encString", encString);
		Response.Cookies.Add(cookie);
	}



	// 二个临时方法，检验测试代码能不能正常运行。
	// 可以在二个调用的地方设置断点，查看结果。

	private void ReadCookie_3()
	{
		TestClass.Read();
	}

	private void WriteCookie_3()
	{
		TestClass.Write();
	}


}
