﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.IO;
using System.Text;

public partial class Default3 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		if( this.IsPostBack == false )
			return;


		SendHttpDEMO();		
    }


	private static string SendHttpRequestGet(string url, Encoding encoding, 
			CookieContainer cookieContainer)
	{
		if( string.IsNullOrEmpty(url) )
			throw new ArgumentNullException("url");

		if( encoding == null )
			throw new ArgumentNullException("encoding");

		HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
		request.Method = "GET";
		request.CookieContainer = cookieContainer;
		
		using( WebResponse response = request.GetResponse() ) {
			using( StreamReader reader = new StreamReader(response.GetResponseStream(), encoding) ) {
				return reader.ReadToEnd();
			}
		}
	}

	private void SendHttpDEMO()
	{
		StringBuilder sb = new StringBuilder();
		CookieContainer cookieContainer = new CookieContainer();

		string url = "http://www.taobao.com";
		SendHttpRequestGet(url, Encoding.Default, cookieContainer);

		// 后面可以继续发起HTTP请求，此时将会包含上次从服务器写入的Cookie
		//SendHttpRequestGet("同域名下的其它URL", Encoding.Default, cookieContainer);

		// 至此，我们可以显示取得了哪些Cookie
		CookieCollection cookies = cookieContainer.GetCookies(new Uri(url));
		if( cookies != null ) {
			foreach( System.Net.Cookie cookie in cookies )
				sb.AppendLine(cookie.ToString());
		}
		txtCookies.Text = sb.ToString();
	}
}
